//3456789112345678921234567893123456789412345678951234567896123456789712345678981234567899123456789012345

#include <stdio.h>
#include <dos.h>

#include "../include/digitmar.h"
#include "../include/pc.h"

int Port=SERIC_PC_COM1; //The default port is COM1.

char *PortSetup="The COM%d port is set up with the Baud rate 9600.\r\n";

int iNewTool=-1;

//Receive the coordinates and the combination key
char GetXY (SERICOND_Point *Point) {
   int i, ii; char Ch;
   for(i=0; i<4; i++) {
      ii=0;
      while(!ii) ii=seric_In(Port, &Ch);
      ((char*)Point)[i]=Ch;}
   ii=0;
   while(!ii) ii=seric_In(Port, &Ch);
   return Ch;
}

void DispClicks (char *What) {
   SERICOND_Point Point;
   SERICOND_Rect Rect;
   char Buffer[100];
   char Combi=GetXY(&Point);
   strcpy(Buffer, "\r\n");
   if( (Point.x<20) || (Point.x>280) || (Point.y<180) || (Point.y>195) ) {
      strcat(Buffer, "Out of Test-Area");}
   else {
      strcat(Buffer, What);
      if(Combi&SERIC_Clicks_Ctrl) strcat(Buffer, "+Ctrl");
      if(Combi&SERIC_Clicks_Shift) strcat(Buffer, "+Shift");}
   Rect.left=20; Rect.top=120; Rect.right=280; Rect.bottom=170;
   seric_Solid(Port, &Rect, SERIC_DefBkBrush);
   seric_DrawStr(Port, Buffer, &Rect, SERIC_DT_Center);
   seric_ShowCanvas(Port, &Rect, -1);
}

int iDrawOnNullRect=0;

int main () {
   printf("Welcome to Demo. Now the PC is going to work as a target.\r\n");
   seric_InitCOM(Port, 9600);
   printf(PortSetup, 1);
   printf("Press 1 or 2 to use COM1 or COM2, or X to exit.\r\n");
   char key, Buffer[2]={0,0};
   int i;
   SERICOND_Rect Rect;
   SERICOND_Point Point1, Point2;
   while(1) {
      //-------------------------------------------------- Keyboard
      if(kbhit()) {
         key=getch();
         switch(key) {
            case 'x':
               return;
            case '1':
               Port=SERIC_PC_COM1;
               seric_InitCOM(Port, 9600);
               printf(PortSetup, 1);
               break;
            case '2':
               Port=SERIC_PC_COM2;
               seric_InitCOM(Port, 9600);
               printf(PortSetup, 2);}}
      //------------------------------------------------ Communication
      if(seric_In(Port, Buffer)) {
         printf(Buffer);
         switch(Buffer[0]) { // Routines for each command, while 'l' and 'r' are not commands.  
            case 'q': //Turn into Function Mode.
               seric_FunctionMode(Port);
               break;
            case 't': //Print numbers.
               seric_PrintStr(Port, "----- A Text UI Example -----\r\n");
               seric_Print1u(Port, "VoltA = %d V\r\n", 255);
               seric_Print1(Port, "VoltB = %d V,", -128);
               seric_Print1(Port, "  VoltC = %d V\r\n", 127);
               seric_Print2u(Port, "CurrentA = %d uA\r\n", 32767);
               seric_Print2(Port, "CurrentB = %d uA,", -32767);
               seric_Print2(Port, "  CurrentC = %d uA\r\n", 32767);
               seric_Print4(Port, "TimeB= %d ms,", -2147483647);
               seric_Print4(Port, "  TimeC = %d ms\r\n", 2147483647);
               seric_Print8f(Port, "ForceB= %5.2e N,", -1.7e308);
               seric_Print8f(Port, "  ForceC = %5.2e N\r\n", 1.7e308);
               break;
            case 'T': //Print numbers allowed only in the full license.
               seric_PrintStr(Port, "----- Only for the Full License -----\r\n");
               seric_Print2u(Port, "CurrentA = %d uA\r\n",  65535);
               seric_Print2(Port, "CurrentB = %d uA,", -1);
               seric_Print2(Port, "  CurrentC = %d uA\r\n", 1);
               seric_Print4(Port, "TimeB= %d ms,", -1);
               seric_Print4(Port, "  TimeC = %d ms\r\n", 1);
               seric_Print8f(Port, "ForceB= %4.2f N,", -1.5);
               seric_Print8f(Port, "  ForceC = %4.2f N\r\n", 1.5);
               break;
            case '1': //New canvas.
               seric_NewCanvas(Port, 300, 200);
               break;
            case '2': //New large canvas allowed only in the full license.
               seric_NewCanvas(Port, 600, 400);
               break;
            case '3': //New very large canvas allowed only in the full license.
               seric_NewCanvas(Port, 6000, 4000); // The values will shrink to fit into the display.
               break;
            case '4': //New canvas, small enough to see the Freezing with a margin.
               seric_NewCanvas(Port, 100, 50);
               break;
            case 's': //Show a part.
               Rect.left=0; Rect.top=0; Rect.right=150; Rect.bottom=200;
               seric_ShowCanvas(Port, &Rect, -1);
               break;
            case 'S': //Show all.
               seric_ShowCanvas(Port, 0, -1);
               break;
            case 'e': //Erase a part.
               Rect.left=0; Rect.top=0; Rect.right=150; Rect.bottom=200;
               seric_ShowCanvas(Port, &Rect, SERIC_DefBkBrush);
               break;
            case 'E': //Erase all.
               seric_ShowCanvas(Port, 0, SERIC_DefBkBrush);
               break;
            case 'w':  //Select the neW tool.
               seric_SelectPaintTool(Port, iNewTool);
               break;
            case 'b': //Create a Brush.
               iNewTool=14;
               seric_NewBrush(Port, iNewTool, 0x8888ff);
               break;
            case 'p': //Create a Pen.
               iNewTool=15;
               seric_NewPen(Port, iNewTool, 0xff0000, 3);
               break;
            case 'f': //Create a Font.
               iNewTool=16;
               seric_NewFont(Port, iNewTool, "Times New Roman", 7, 15, 700,
                               SERIC_Font_Italic | SERIC_Font_Underline | SERIC_Font_StrikeOut);
               break;
            case 'c': //Set the text Color.
               seric_SetTextColor(Port, 0x8888ff);
               break;
            case 'g': //Draw numbers.
               Rect.left=50; Rect.top=5; Rect.right=250; Rect.bottom=20;
               seric_Rectangle(Port, &Rect);
               seric_DrawStr(Port, "GUI Example 1", &Rect, SERIC_DT_Center);
               Rect.left=20; Rect.top=30; Rect.right=280; Rect.bottom=45;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw1u(Port, "VoltA = %d V", 255, &Rect, SERIC_DT_Center);
               Rect.left=20; Rect.top=50; Rect.right=150; Rect.bottom=65;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw1(Port, "VoltB = %d V", -128, &Rect, 0);
               Rect.left=150; Rect.top=50; Rect.right=280; Rect.bottom=65;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw1(Port, "VoltC = %d V", 127, &Rect, SERIC_DT_Right);
               break;
            case 'h': //Draw more numbers.
               Rect.left=50; Rect.top=5; Rect.right=250; Rect.bottom=20;
               seric_Rectangle(Port, &Rect);
               seric_DrawStr(Port, "GUI Example 2", &Rect, SERIC_DT_Center);
               Rect.left=20; Rect.top=30; Rect.right=280; Rect.bottom=45;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw2u(Port, "CurrentA = %d uA", 32767, &Rect, SERIC_DT_Center);
               Rect.left=20; Rect.top=50; Rect.right=150; Rect.bottom=65;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw2(Port, "CurrentB = %d uA", -32767, &Rect, 0);
               Rect.left=150; Rect.top=50; Rect.right=280; Rect.bottom=65;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw2(Port, "CurrentC = %d uA", 32767, &Rect, SERIC_DT_Right);
               Rect.left=20; Rect.top=70; Rect.right=150; Rect.bottom=85;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw4(Port, "tB= %d ms", -2147483647, &Rect, 0);
               Rect.left=150; Rect.top=70; Rect.right=280; Rect.bottom=85;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw4(Port, "tC = %d ms", 2147483647, &Rect, SERIC_DT_Right);
               Rect.left=20; Rect.top=90; Rect.right=150; Rect.bottom=105;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw8f(Port, "ForceB= %5.2e N", -1.7e308, &Rect, 0);
               Rect.left=150; Rect.top=90; Rect.right=280; Rect.bottom=105;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw8f(Port, "ForceC = %5.2e N", 1.7e308, &Rect, SERIC_DT_Right);
               break;
            case 'H': //Draw numbers allowed only in the full license.  
               seric_ShowCanvas(Port, 0, SERIC_DefBkBrush);
               Rect.left=50; Rect.top=5; Rect.right=250; Rect.bottom=20;
               seric_Rectangle(Port, &Rect);
               seric_DrawStr(Port, "Only for the Full License", &Rect, SERIC_DT_Center);
               Rect.left=20; Rect.top=30; Rect.right=280; Rect.bottom=45;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw2u(Port, "CurrentA = %d uA", 65535, &Rect, SERIC_DT_Center);
               Rect.left=20; Rect.top=50; Rect.right=150; Rect.bottom=65;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw2(Port, "CurrentB = %d uA", -1, &Rect, 0);
               Rect.left=150; Rect.top=50; Rect.right=280; Rect.bottom=65;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw2(Port, "CurrentC = %d uA", 1, &Rect, SERIC_DT_Right);
               Rect.left=20; Rect.top=70; Rect.right=150; Rect.bottom=85;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw4(Port, "tB= %d ms", -1, &Rect, 0);
               Rect.left=150; Rect.top=70; Rect.right=280; Rect.bottom=85;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw4(Port, "tC = %d ms", 1, &Rect, SERIC_DT_Right);
               Rect.left=20; Rect.top=90; Rect.right=150; Rect.bottom=105;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw8f(Port, "ForceB= %4.2f N", -1.5, &Rect, 0);
               Rect.left=150; Rect.top=90; Rect.right=280; Rect.bottom=105;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_Draw8f(Port, "ForceC = %4.2f N", 1.5, &Rect, SERIC_DT_Right);
               seric_ShowCanvas(Port, 0, -1);
               break;
            case 'd': //Draw many things.
               seric_ShowCanvas(Port, 0, SERIC_DefBkBrush);
               // Title
               Rect.left=50; Rect.top=5; Rect.right=250; Rect.bottom=20;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_DrawStr(Port, "A Graphic UI Example", &Rect, SERIC_DT_Center);
               // Square Wave
               Point1.x=20; Point1.y=30;
               Point2.x=20; Point2.y=30+20;
               for(i=0; i<3; i++) {
                  Point2.x+=35; Point2.y-=20;
                  seric_Line(Port, &Point1, &Point2);
                  Point1.x+=35; Point1.y+=20;
                  seric_Line(Port, &Point1, &Point2);
                  Point2.x+=35; Point2.y+=20;
                  seric_Line(Port, &Point1, &Point2);
                  Point1.x+=35; Point1.y-=20;
                  seric_Line(Port, &Point1, &Point2);}
               // Figure on the right of the wave
               Rect.left=240; Rect.top=30; Rect.right=280; Rect.bottom=50;
               seric_Solid(Port, &Rect, SERIC_DefBrush);
               // Figures below the wave
               Rect.left=20; Rect.top=60; Rect.right=60; Rect.bottom=80;
               Point1.x=60; Point1.y=80;
               Point2.x=20; Point2.y=80;
               seric_Arc(Port, &Rect, &Point1, &Point2);
               Rect.left=70; Rect.top=60; Rect.right=110; Rect.bottom=80;
               seric_Rectangle(Port, &Rect);
               Rect.left=120; Rect.top=60; Rect.right=160; Rect.bottom=80;
               seric_Ellipse(Port, &Rect);
               Rect.left=170; Rect.top=60; Rect.right=210; Rect.bottom=80;
               seric_rRectangle(Port, &Rect, 10, 6);
               Rect.left=20; Rect.top=90; Rect.right=60; Rect.bottom=110;
               Point1.x=60; Point1.y=110;
               Point2.x=20; Point2.y=110;
               seric_Pie(Port, &Rect, &Point1, &Point2);
               Rect.left=70; Rect.top=90; Rect.right=110; Rect.bottom=110;
               Point1.x=110; Point1.y=110;
               Point2.x=70; Point2.y=110;
               seric_Chord(Port, &Rect, &Point1, &Point2);
               // Clicks-Test/Result Areas
               Rect.left=20; Rect.top=120; Rect.right=280; Rect.bottom=170;
               seric_DrawStr(Port, "\r\nSend k, before clicking below", &Rect, SERIC_DT_Center);
               Rect.left=20; Rect.top=180; Rect.right=280; Rect.bottom=195;
               seric_Frame(Port, &Rect, SERIC_DefBrush);
               seric_DrawStr(Port, "Click here with or without Shift/Ctrl", &Rect, SERIC_DT_Center);
               seric_ShowCanvas(Port, 0, -1);
               break;
            case 'i': //Invert a part.
               Rect.left=0; Rect.top=0; Rect.right=150; Rect.bottom=200;
               seric_Invert(Port, &Rect);
               seric_ShowCanvas(Port, &Rect, -1);
               break;
            case 'I': //Invert all.
               seric_Invert(Port, 0);
               seric_ShowCanvas(Port, 0, -1);
               break;
            case 'k': //Enable clicks.
               seric_EnableClicks(Port, 'l', 'r');
               break;
            case 'l': //Left mouse button is clicked.
               DispClicks("Left Click");
               break;
            case 'r': //Right mouse button is clicked.
               DispClicks("Right Click");
               break;
            case 'n': //Drawing functions with "NULL Rect", to see that they draw on the entire canvas.
               seric_ShowCanvas(Port, 0, SERIC_DefBkBrush);
               Point1.x=250; Point1.y=0;
               Point2.x=0; Point2.y=80;
               switch(iDrawOnNullRect%9) { //Circulate around 8 pictures when you repeat 'n'.
                  case 0:
                     seric_DrawStr(Port, "Example Texts by Ftns with Empty Rects:", 0, SERIC_DT_Center);
                     seric_Draw1u(Port, "\r\n\r\nVoltA = %d V", 255, 0, 0);
                     seric_Draw1(Port, "\r\n\r\nVoltC = %d V", 127, 0, SERIC_DT_Right);
                     seric_Draw2u(Port, "\r\n\r\n\r\n\r\nCurrentA = %d uA", 32767, 0, 0);
                     seric_Draw2(Port, "\r\n\r\n\r\n\r\nCurrentC = %d uA", 32767, 0, SERIC_DT_Right);
                     seric_Draw4(Port, "\r\n\r\n\r\n\r\n\r\n\r\ntC = %d ms",
                                                                     2147483647, 0, SERIC_DT_Center);
                     seric_Draw8f(Port, "\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nForceC = %5.2e N",
                                                                        1.7e308, 0, SERIC_DT_Center);
                     break;
                  case 1:
                     seric_Solid(Port, 0, SERIC_DefBrush);
                     break;
                  case 2:
                     seric_Frame(Port, 0, SERIC_DefBrush);
                     break;
                  case 3:
                     seric_Arc(Port, 0, &Point1, &Point2);
                     break;
                  case 4:
                     seric_Rectangle(Port, 0);
                     break;
                  case 5:
                     seric_Ellipse(Port, 0);
                     break;
                  case 6:
                     seric_rRectangle(Port, 0, 30, 15);
                     break;
                  case 7:
                     seric_Pie(Port, 0, &Point1, &Point2);
                     break;
                  case 8:
                     seric_Chord(Port, 0, &Point1, &Point2);}
               seric_ShowCanvas(Port, 0, -1);
               iDrawOnNullRect++;}}}
}
